// This is a quick and dirty hack to add CR to all LFs in a file.
// this is for systems that need CRLF at the end of a line

//  BTW, here's how you do it for an entire filetree in Unix:
//  create a file called update that contains this line:
//    unix2dos -ascii $1 $1
// then execute this command:
//    find . -name \*.java -exec update {} \;
// this is why people think Unix is cryptic.  It is.

// E.g. NT's notepad editor.
// OR, instead of filtering files thru this program, use a better editor.
//
// Compile the program with    javac crlf.java

// Run the program with        java crlf < mycode.java  > mycodeCR.java
//                             rename mycodeCR.java   mycode.java

// Peter van der Linden, St Patrick's Day (Mar 17) 1998.

import java.io.*;
class lfcr {
    public static void main(String s[]) throws IOException {
        int c;
        while ( (c=System.in.read())!= -1) {
             System.out.write(c);
             if (c=='\r') System.out.write('\n');
        }
    }
}
